﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;  
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.WebDataGrid1.DataFiltered += new Infragistics.Web.UI.GridControls.DataFilteredHandler(WebDataGrid1_DataFiltered);
        this.WebDataGrid1.DataFiltering += WebDataGrid1_DataFiltering;

        this.WebDataGrid1.ColumnSorted += new Infragistics.Web.UI.GridControls.ColumnSortedHandler(WebDataGrid1_ColumnSorted);
        this.WebDataGrid1.PageIndexChanged += new PageIndexChangedHandler(WebDataGrid1_PageIndexChanged);
        this.WebDataGrid1.PreRender += new EventHandler(WebDataGrid1_PreRender);

       
        

        if (!IsPostBack)
            Session["data"] = MakeTable();        
    }

    void WebDataGrid1_DataFiltering(object sender, FilteringEventArgs e)
    {
        e.Cancel = true;
        
    }

    void WebDataGrid1_PageIndexChanged(object sender, PagingEventArgs e)
    {
        this.WebDataGrid1.DataSource = ((DataTable)Session["data"]);     
    }

    void WebDataGrid1_PreRender(object sender, EventArgs e)
    {
        foreach (GridRecord row in this.WebDataGrid1.Rows)
        {
            row.Items.FindItemByKey("ProdDiffQty").Value = 
                int.Parse(row.Items.FindItemByKey("id").Value.ToString()) + 
                int.Parse(row.Items.FindItemByKey("NumericColumn").Value.ToString());
        }
    }

    void WebDataGrid1_ColumnSorted(object sender, Infragistics.Web.UI.GridControls.SortingEventArgs e)
    {
        this.WebDataGrid1.DataSource = ((DataTable)Session["data"]);      
    }

    void WebDataGrid1_DataFiltered(object sender, Infragistics.Web.UI.GridControls.FilteredEventArgs e)
    {
        this.WebDataGrid1.DataSource = ((DataTable)Session["data"]).DefaultView.ToTable(); //  MakeTable().DefaultView.ToTable();
        //this.WebDataGrid1.DataBind();
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        this.WebDataGrid1.DataSource = ((DataTable)Session["data"]);
    }
    private DataTable MakeTable()
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "NumericColumn";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);


        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table. 
        table.Columns.Add(column);

        // Create third column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        // Make the ID column the primary key column.
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;



        for (int i = 0; i <= 500; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = "Item " + i;
            row["Data"] = "Data " + i;
            row["NumericColumn"] = (i < 10) ? i -2 : i + 2;
            table.Rows.Add(row);
        }
        return table;

    }



}